/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Boolean_$type, typeCast, Type, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type } from "igniteui-react-core/ES2015/type";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { Extensions } from "igniteui-react-core/ES2015/Extensions";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "igniteui-react-core/ES2015/MathUtil";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { isNaN_, isInfinity } from "igniteui-react-core/ES2015/number";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { RangeInfo } from "./RangeInfo";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
export class AngleAxisLabelPanel extends AxisLabelPanelBase {
    constructor() {
        super();
        this.ct = false;
        this.cz = null;
        this.cx = 0;
        this.cu = 0;
        this.cw = 0;
        this.cv = 0;
    }
    ad() {
        return new AngleAxisLabelPanelView(this);
    }
    b8(a) {
        super.b8(a);
        this.cs = a;
    }
    ao(a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.it.isEmpty) {
            return super.ao(a, b);
        }
        return true;
    }
    ay() {
        let a = new List$1(Rect.$, 0);
        let b = new List$1(Boolean_$type, 0);
        if (this.a3.count != this.a2.count) {
            return a;
        }
        this.cs.ay(a, b);
        let c = false;
        this.am = this.al(a, b);
        if (!this.ac.bz()) {
            c = true;
            this.a9 = this.cx / 2;
            this.a9 = this.a9 + this.cy();
        }
        else {
            c = true;
            this.cs.ac();
        }
        if (c) {
            for (let d = 0; d < a.count; d++) {
                let e = this.a3._inner[d];
                let f = this.a2._inner[d];
                let g = a._inner[d];
                let h = this.cz(f.d);
                let i = h.x - this.bc(e) / 2;
                let j = h.y - this.bb(e) / 2;
                g.x = i;
                g.y = j;
                a._inner[d] = g;
            }
        }
        return a;
    }
    cy() {
        let a;
        let b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.bf);
        }
        if (a == null || b == null) {
            return 0;
        }
        let c = new List$1(Axis.$, 0);
        for (let d = 0; d < a.axes.count; d++) {
            let e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.at) !== null && e.at.a3.count > 0 && (!e.bz()) && !e.by() && (e.ag == null || this.ac.ag == null || e.ag.lb == b.ag.lb)) {
                c.add(e);
            }
        }
        let f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        let g = 0;
        let h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].at.a9;
            g += c._inner[f].at.a9 * 2 + h;
        }
        return g;
    }
    ah() {
        return 4;
    }
    as(a) {
        return a == 4 || a == 5;
    }
}
AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
export class CategoryAngleAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.ku = null;
        this.kr = null;
        this.kv = false;
        this.kz = NaN;
        this.ks = null;
        this.k0 = 0;
        this.kx = 0;
        this.ky = 0;
        this.lb = 1;
        this.ab = CategoryAngleAxis.$;
        this.kr = this.kq();
        this.ku = new PolarAxisRenderingManager();
    }
    a1() {
        return new CategoryAngleAxisView(this);
    }
    gl(a) {
        super.gl(a);
        this.kp = a;
    }
    get_b0() {
        return true;
    }
    get b0() {
        return this.get_b0();
    }
    as() {
        let a = new AngleAxisLabelPanel();
        a.cz = (b) => {
            let c = this.bf != null ? this.bf.mk : Rect.empty;
            let d = !c.isEmpty ? this.it : Rect.empty;
            return this.lo(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.at.a9);
        };
        return a;
    }
    k9(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    kq() {
        let a = ((() => {
            let $ret = new AxisLabelManager();
            $ret.a = this;
            $ret.f = this.ct;
            $ret.e = this.cs;
            $ret.b = this.at;
            return $ret;
        })());
        if (this.aw != null) {
            this.aw.registerAxis(this);
        }
        let b = new CategoryAxisRenderer(a);
        b.u = () => {
            let c = this.a2.ax();
            let d = this.a2.a0();
            let e = this.a2.ay();
            let f = this.a2.az();
            this.g7();
            this.gb(c);
            this.gb(d);
            this.gb(e);
            this.gb(f);
        };
        b.o = (c, d) => !d.isEmpty && !c.isEmpty && this.kt != null;
        b.d = (c, d, e, f) => this.ko(c, d, e, f);
        b.v = () => {
            if (!this.kv) {
                this.kv = true;
                this.kt.ck();
                this.kv = false;
            }
        };
        b.g = (c) => {
            let d = typeGetValue(c);
            if (d > this.i7.count - 1) {
                d -= this.i7.count;
            }
            let e = this.i7.item(d);
            return this.e0(e);
        };
        b.b.c = (c) => {
            if ((this.aw == null || this.aw.visibility == 0) && this.kt != null && this.kz != c) {
                let d = typeCast(XamDataChart.$, this.bf);
                if (d == null) {
                    return;
                }
                this.kz = c;
                this.at.a8 = c;
                d.hp();
                for (let e of fromEnum(d.axes)) {
                    if (e != this && typeCast(AngleAxisLabelPanel.$, e.at) !== null) {
                        e.a2.ac();
                    }
                }
            }
        };
        b.k = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            this.ku.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = (c, d, e, f) => {
            let g = typeCast(RadialAxisRenderingParameters.$, c);
            this.ku.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = (c, d) => this.getScaledAngle(d);
        b.q = (c, d) => {
            if (this.k9(d - this.k0) < 0) {
                return false;
            }
            if (this.k9(d - this.k0 - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = (c) => {
            let d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                this.ku.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = (c) => {
            c.n = this.k3();
            c.r = c.n;
        };
        b.p = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            let g = this.lo(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = (c, d, e, f) => {
            let g = c.y;
            let h = new ScalerParams(0, c.aa, c.z, this.b8, g);
            let i = d;
            if (this.categoryMode != 0) {
                let j = (e * f) + 1;
                j = Math.min(j, this.jq);
                let k = this.dt(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.k6);
        return b;
    }
    lo(a, b, c, d, e) {
        let f = this.k3();
        let g = ViewportUtils.b(e, c, d);
        if (this.aw != null && (this.aw.c == 5 || this.aw.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    k3() {
        if (this.kt == null) {
            return 0;
        }
        if (!this.by()) {
            return this.kt.lg();
        }
        else {
            return this.kt.lh((this.ey));
        }
    }
    ko(a, b, c, d) {
        if (this.i7 == null) {
            return null;
        }
        let e = new RadialAxisRenderingParameters();
        let f = this.i7.count - 1;
        let g = this.a2.ax();
        let h = this.a2.a0();
        let i = this.a2.ay();
        let j = this.a2.az();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.kw();
        e.p = this.k7;
        e.o = this.d6();
        e.q = this.k8;
        e.s = this.e1;
        let k = this.ku.f(b);
        let l = this.ku.g(b);
        let m = 0.5 * this.kt.lb;
        let n = 0.5 * this.kt.la;
        let o = k;
        let p = l;
        let q = this.kt.lg();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        let r = a.width;
        this.ku.k(b, e, 0, this.i7.count, this.b8, runOn(this, this.getUnscaledAngle), r);
        let s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.i7.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.b8;
        e.af = this.jt;
        e.f = new CategoryTickmarkValues();
        e.j = this.ci;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.ku.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    ac() {
        super.ac();
        this.gz(false);
    }
    get kt() {
        if (this.ks != null) {
            return this.ks;
        }
        let a = typeCast(XamDataChart.$, this.bf);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.ks;
    }
    set kt(a) {
        this.ks = a;
    }
    ah() {
        return this.kt;
    }
    getCategorySize(a, b, c) {
        return 2 * Math.PI / this.jq;
    }
    jj(a, b, c) {
        let d = !isNaN_(this.jg) ? MathUtil.b(this.jg, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.jn)) {
            e = Math.min(this.jn, 1);
        }
        let f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.jt - (this.jt - 1) * e);
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.jt > 1) {
            let f = !isNaN_(this.jg) ? MathUtil.b(this.jg, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.jn)) {
                g = Math.min(this.jn, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.jt - (this.jt - 1) * g);
            let j = (h - i) / (this.jt - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    k6(a) {
        let b = 0.5;
        if (this.jt > 1) {
            let c = !isNaN_(this.jg) ? MathUtil.b(this.jg, 0, 1) : 0;
            let d = 0;
            if (!isNaN_(this.jn)) {
                d = Math.min(this.jn, 1);
            }
            let e = 1 - 0.5 * c;
            let f = e / (this.jt - (this.jt - 1) * d);
            let g = (e - f) / (this.jt - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    }
    g0(a) {
        super.g0(a);
        let b = this.bf != null ? this.bf.mk : Rect.empty;
        let c = !b.isEmpty ? this.it : Rect.empty;
        let d = this.io();
        let e = this.im();
        let f = this.kr.c(a, c, b, d, e);
        if (f != null) {
            this.k1 = f.f.m;
            this.k2 = f.f.l;
        }
    }
    k5(a, b) {
        let c;
        let d;
        let e = this.ku.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.b8) {
                return this.jq;
            }
            else {
                return 0;
            }
        }
        let f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.jq) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    }
    k4(a, b) {
        let c;
        let d;
        let e = this.ku.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.b8) {
                return 0;
            }
            else {
                return this.jq;
            }
        }
        let f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.jq) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    }
    getScaledAngle(a) {
        let b = this.jq;
        let c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.b9) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.k0;
    }
    getUnscaledAngle(a) {
        if (a < this.k0) {
            a += 2 * Math.PI;
        }
        let b = (a - this.k0) / (2 * Math.PI);
        if (this.b8) {
            b = 1 - b;
        }
        return b * (this.jq);
    }
    dt(a, b) {
        return this.getScaledAngle(a);
    }
    dw(a, b) {
        return this.getUnscaledAngle(a);
    }
    gn(a, b, c, d) {
        super.gn(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bf);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.lk(f);
                if (f != null) {
                    f.lq(this);
                }
                this.cf = true;
                this.gz(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.k0 = this.la;
                while (this.k0 < 0) {
                    this.k0 += 360;
                }
                while (this.k0 >= 360) {
                    this.k0 -= 360;
                }
                this.k0 = (this.k0 * Math.PI) / 180;
                this.cf = true;
                this.gz(false);
                for (let g of fromEnum(this.cu)) {
                    g.i1(false);
                    g.h8();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.cf = true;
                        h.gy();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.cf = true;
                            i.gy();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.kr = this.kq();
                this.li();
                this.cf = true;
                this.gz(false);
                break;
        }
    }
    li() {
        this.kz = NaN;
    }
    lk(a) {
        this.kt = a;
    }
    get k7() {
        return this.c(CategoryAngleAxis.ll);
    }
    set k7(a) {
        this.h(CategoryAngleAxis.ll, a);
    }
    get k1() {
        return this.kx;
    }
    set k1(a) {
        if (this.k1 != a) {
            let b = this.kx;
            this.kx = a;
            this.gt("ActualInterval", b, this.k1);
        }
    }
    d4() {
        return this.k1;
    }
    get k8() {
        return this.c(CategoryAngleAxis.lm);
    }
    set k8(a) {
        this.h(CategoryAngleAxis.lm, a);
    }
    get k2() {
        return this.ky;
    }
    set k2(a) {
        if (this.k2 != a) {
            let b = this.ky;
            this.ky = a;
            this.gt("ActualMinorInterval", b, this.k2);
        }
    }
    kw() {
        return false;
    }
    get_az() {
        return 2;
    }
    get az() {
        return this.get_az();
    }
    cm() {
        if (this.cf && this.cn) {
            this.a9 = this.a8();
        }
        if (this.i7 == null) {
            return false;
        }
        let a = this.i7.count;
        if (a != this.lc) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.lc, a);
            this.lc = a;
            this.gu(b);
            return true;
        }
        return false;
    }
    get lc() {
        return this.lb;
    }
    set lc(a) {
        this.lb = a;
    }
    get isVertical() {
        return this.ce;
    }
    j$c(a, b) {
        return this.dw.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dt.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gf.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gg.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gh.apply(this, arguments);
    }
    get j$a() {
        return this.b8;
    }
}
CategoryAngleAxis.ll = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.gt("Interval", b.oldValue, b.newValue);
    a.gz(false);
}));
CategoryAngleAxis.lm = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryAngleAxis.$, a)).gt("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryAngleAxis.$, a)).gz(false);
}));
CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
Type.dep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'gt', ['StartAngleOffset:la:ln', [1, 0]]);
export class NumericAngleAxis extends NumericAxisBase {
    constructor() {
        super();
        this.k7 = null;
        this.k8 = false;
        this.k9 = NaN;
        this.la = 0;
        this.k5 = null;
        this.ab = NumericAngleAxis.$;
        this.k7 = new PolarAxisRenderingManager();
        this.i7 = this.i5();
    }
    a1() {
        return new NumericAngleAxisView(this);
    }
    gl(a) {
        super.gl(a);
        this.k4 = a;
    }
    get_b0() {
        return true;
    }
    get b0() {
        return this.get_b0();
    }
    as() {
        let a = new AngleAxisLabelPanel();
        a.cz = (b) => {
            let c = this.bf != null ? this.bf.mk : Rect.empty;
            let d = !c.isEmpty ? this.it : Rect.empty;
            return this.lk(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.at.a9);
        };
        return a;
    }
    lb() {
        if (this.k6 == null) {
            return 0;
        }
        if (!this.by()) {
            return this.k6.lg();
        }
        else {
            return this.k6.lh((this.ey));
        }
    }
    ld(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    i5() {
        let a = super.i5();
        a.b.c = (b) => {
            if ((this.aw == null || this.aw.visibility == 0) && this.k6 != null && this.k9 != b) {
                let c = typeCast(XamDataChart.$, this.bf);
                if (c == null) {
                    return;
                }
                this.k9 = b;
                this.at.a8 = b;
                c.hp();
                for (let d of fromEnum(c.axes)) {
                    if (d != this && typeCast(AngleAxisLabelPanel.$, d.at) !== null) {
                        d.a2.ac();
                    }
                }
            }
        };
        a.e = (b) => {
            b.n = this.lb();
            b.r = b.n;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                this.k7.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.k7.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.k7.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, this.i8(b, c, d, e));
            return f;
        };
        a.v = () => {
            if (!this.k8) {
                this.k8 = true;
                this.k6.ck();
                this.k8 = false;
            }
        };
        a.m = (b, c) => this.getScaledAngle(c);
        a.o = (b, c) => !c.isEmpty && !b.isEmpty && this.k6 != null;
        a.q = (b, c) => {
            if (this.ld(c - this.la) < 0) {
                return false;
            }
            if (this.ld(c - this.la - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            let f = this.lk(this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            let g = this.lk(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = (b, c, d, e) => {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    lk(a, b, c, d, e) {
        let f = this.lb();
        let g = ViewportUtils.b(e, c, d);
        if (this.aw != null && (this.aw.c == 5 || this.aw.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    dt(a, b) {
        return this.getScaledAngle(a);
    }
    getScaledAngle1(a, b, c) {
        let d = 0;
        if (b) {
            d = (Math.log(a) - this.j2) / (this.j1 - this.j2);
        }
        else {
            d = (a - this.jw) / (this.jv - this.jw);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.la;
    }
    getScaledAngle(a) {
        return this.getScaledAngle1(a, this.jm, this.b9);
    }
    dw(a, b) {
        return this.getUnscaledAngle(a);
    }
    getUnscaledAngle(a) {
        let b = (a - this.la) / (2 * Math.PI);
        if (this.b8) {
            b = 1 - b;
        }
        if (this.jm) {
            return Math.exp(b * (this.j1 - this.j2) + this.j2);
        }
        else {
            return this.jw + b * (this.jv - this.jw);
        }
    }
    gn(a, b, c, d) {
        super.gn(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bf);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.li(f);
                if (f != null) {
                    f.lq(this);
                }
                this.gz(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.la = this.le;
                while (this.la < 0) {
                    this.la += 360;
                }
                while (this.la >= 360) {
                    this.la -= 360;
                }
                this.la = (this.le * Math.PI) / 180;
                this.gz(false);
                for (let g of fromEnum(this.cr())) {
                    g.i1(false);
                    g.h8();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.gy();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.gy();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.i7 = this.i5();
                this.lg();
                this.cf = true;
                this.gz(false);
                break;
        }
    }
    lg() {
        this.k9 = NaN;
    }
    i9() {
        return new PolarAxisRenderingParameters();
    }
    i8(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.i8(a, b, c, d));
        let f = this.k7.f(b);
        let g = this.k7.g(b);
        let h = 0.5 * this.k6.lb;
        let i = 0.5 * this.k6.la;
        let j = f;
        let k = g;
        let l = this.k6.lg();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        let m = a.width;
        this.k7.k(b, e, this.jw, this.jv, this.b8, runOn(this, this.getUnscaledAngle), m);
        let n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.k7.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    g0(a) {
        super.g0(a);
        let b = this.bf != null ? this.bf.mk : Rect.empty;
        let c = !b.isEmpty ? this.it : Rect.empty;
        let d = this.io();
        let e = this.im();
        let f = this.i7.c(a, c, b, d, e);
        if (f != null) {
            this.ju = f.f.m;
            this.jx = f.f.l;
        }
    }
    get k6() {
        if (this.k5 != null) {
            return this.k5;
        }
        let a = typeCast(XamDataChart.$, this.bf);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (a.axes._inner[b].cb) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.k5;
    }
    set k6(a) {
        this.k5 = a;
    }
    ah() {
        return this.k6;
    }
    li(a) {
        this.k6 = a;
    }
    ha(a, b) {
        super.ha(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.ck();
        }
    }
    get_az() {
        return 2;
    }
    get az() {
        return this.get_az();
    }
}
NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
Type.dep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'gt', ['StartAngleOffset:le:lj', [1, 0]]);
export class NumericRadiusAxis extends NumericAxisBase {
    constructor() {
        super();
        this.k7 = null;
        this.k8 = false;
        this.k9 = NaN;
        this.lb = 0;
        this.la = 0;
        this.ld = 0;
        this.k4 = null;
        this.ab = NumericRadiusAxis.$;
        this.lb = this.ll;
        this.la = this.lk;
        this.k7 = new PolarAxisRenderingManager();
        this.i7 = this.i5();
    }
    a1() {
        return new NumericRadiusAxisView(this);
    }
    gl(a) {
        super.gl(a);
        this.k6 = a;
    }
    get_cb() {
        return true;
    }
    get cb() {
        return this.get_cb();
    }
    ds() {
        let a = this.lb;
        let b = this.la;
        let c = Math.min(this.lf(), this.le()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    }
    lf() {
        return this.it.width;
    }
    le() {
        return this.it.height;
    }
    as() {
        return new RadialAxisLabelPanel();
    }
    lc(a) {
        if (a == null) {
            return 0;
        }
        return a;
    }
    i5() {
        let a = super.i5();
        a.b.c = (b) => {
            if ((this.aw == null || this.aw.visibility == 0) && this.k5 != null) {
                if ((this.aw == null || (this.aw.c == 4 || this.aw.c == 5)) && this.k9 != b) {
                    this.k9 = b;
                    this.at.a8 = b;
                    this.bf.hp();
                }
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.k7.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = (b, c, d, e) => {
            if (d == e) {
                return;
            }
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.k7.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = (b, c) => this.lh(c);
        a.q = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            this.k7.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = (b) => {
            b.n = this.aw == null || (this.aw.c == 4 || this.aw.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (this.lc(this.ey) * Math.PI) / 180;
            if (this.aw == null || (this.aw.c == 4 || this.aw.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                let d = typeCast(RadialAxisLabelPanel.$, this.at);
                if (d != null) {
                    let e = 0;
                    if (this.aw != null && this.aw.c == 4) {
                        e = 1;
                    }
                    d.dg = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.dd = c.crossingAngleRadians;
                }
            }
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            if (this.k5 == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            let f = false;
            f = this.aw == null || (this.aw.c == 4 || this.aw.c == 5);
            let g = 0;
            if (f) {
                g = this.ld;
            }
            let h = e.center.x + c * Math.cos(g);
            let i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = (b, c, d, e) => {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    dt(a, b) {
        return this.lh(a);
    }
    li(a, b, c, d, e) {
        let f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.jw) - this.j2) / (this.j1 - this.j2);
            }
            else {
                f = (Math.log(a) - this.j2) / (this.j1 - this.j2);
            }
        }
        else {
            f = (a - this.jw) / (this.jv - this.jw);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    }
    lh(a) {
        return this.li(a, this.jm, this.b9, this.lb, this.la);
    }
    lj(a) {
        let b = a * 2;
        b = (b - this.la) / (this.lb - this.la);
        if (this.b8) {
            b = 1 - b;
        }
        if (this.jm) {
            return Math.exp(b * (this.j1 - this.j2) + this.j2);
        }
        else {
            return this.jw + b * (this.jv - this.jw);
        }
    }
    dw(a, b) {
        return this.lj(a);
    }
    gn(a, b, c, d) {
        switch (b) {
            case "CrossingValue":
                this.ld = this.lc(this.ey) * Math.PI / 180;
                break;
        }
        super.gn(a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.lb = this.ll;
                if (this.lb < 0) {
                    this.lb = 0.1;
                }
                if (this.lb > 1) {
                    this.lb = 1;
                }
                if (this.la >= this.lb) {
                    this.la = this.lb - 0.01;
                    if (this.la < 0) {
                        this.la = 0;
                        this.lb = 0.01;
                    }
                }
                this.cf = true;
                this.gz(false);
                if (this.k5 != null) {
                    this.k5.gy();
                }
                for (let e of fromEnum(this.cr())) {
                    e.i1(false);
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.la = this.lk;
                if (this.la < 0) {
                    this.la = 0.1;
                }
                if (this.la > 1) {
                    this.la = 1;
                }
                if (this.la >= this.lb) {
                    this.la = this.lb - 0.01;
                    if (this.la < 0) {
                        this.la = 0;
                        this.lb = 0.01;
                    }
                }
                this.cf = true;
                this.gz(false);
                if (this.k5 != null) {
                    this.k5.gy();
                }
                for (let f of fromEnum(this.cr())) {
                    f.di = true;
                    f.i1(false);
                }
                if (this.bf != null) {
                    this.bf.hx();
                }
                break;
            case "CrossingAxis":
                let g = typeCast(NumericAngleAxis.$, d);
                let h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.lq(null);
                }
                if (g != null) {
                    this.lq(g);
                    g.li(this);
                }
                if (h != null) {
                    this.lq(h);
                    h.lk(this);
                }
                this.cf = true;
                this.gz(false);
                break;
            case "IsInverted":
                if (this.k5 != null) {
                    this.k5.cf = true;
                    this.k5.gz(false);
                }
                break;
        }
    }
    lq(a) {
        this.k5 = a;
    }
    get k5() {
        if (this.k4 != null) {
            return this.k4;
        }
        let a = typeCast(XamDataChart.$, this.bf);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.k4;
    }
    set k5(a) {
        this.k4 = a;
    }
    ah() {
        return this.k5;
    }
    i9() {
        return new PolarAxisRenderingParameters();
    }
    i8(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.i8(a, b, c, d));
        let f = this.k7.f(b);
        let g = this.k7.g(b);
        let h = 0.5 * this.lb;
        let i = 0.5 * this.la;
        let j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.mu)) {
            k = this.jv;
            j = this.jw;
        }
        else {
            k = Math.min(g, h);
            j = this.lj(f);
            k = this.lj(k);
            let l = this.lr(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        let m = { $type: Point_$type, x: 0.5, y: 0.5 };
        let n = f;
        let o = g;
        let p = Math.min(a.width, a.height) * (this.lb - this.la) / 2;
        e.center = m;
        let q = Math.max(o, n);
        let r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        let s = Math.min(j, k);
        let t = Math.max(j, k);
        if (s < this.jw) {
            s = this.jw;
        }
        if (t > this.jv) {
            t = this.jv;
        }
        this.jz = s;
        this.jy = t;
        e.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        let u = typeCast(IAngleScaler_$type, this.k5);
        if (u != null) {
            let v;
            let w;
            let x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        let y = this.lg();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.jc;
        let z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.lm(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    }
    lr(a, b, c, d) {
        let e = { $type: Point_$type, x: 0.5, y: 0.5 };
        let f = 0;
        if (this.b8) {
            f = this.lh(this.jw);
        }
        else {
            f = this.lh(this.jv);
        }
        let g = 0;
        if (this.ey != null) {
            g = this.ld;
        }
        let h = e.x + f * Math.cos(g);
        let i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.b8) {
                d = this.jw;
            }
            else {
                d = this.jv;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.b8) {
                c = this.jv;
            }
            else {
                c = this.jw;
            }
        }
        return {
            p2: c,
            p3: d
        };
    }
    lm(a, b, c, d, e) {
        let f = ViewportUtils.d(c - b, d, e);
        let g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    }
    lg() {
        let a = 0;
        if (!this.b8) {
            a = this.lh(this.jv);
        }
        else {
            a = this.lh(this.jw);
        }
        return a;
    }
    ku(a) {
        if (this.k5 != null) {
            this.k5.gy();
        }
    }
    g0(a) {
        super.g0(a);
        let b = this.bf != null ? this.bf.mk : Rect.empty;
        let c = !b.isEmpty ? this.it : Rect.empty;
        let d = this.io();
        let e = this.im();
        let f = this.i7.c(a, c, b, d, e);
        if (f != null) {
            this.ju = f.f.m;
            this.jx = f.f.l;
        }
    }
    ha(a, b) {
        super.ha(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.ck();
        }
    }
    lp(a, b, c, d, e) {
        let f = typeCast(IPolarRadialRenderingParameters_$type, this.i8(b, c, d, e));
        if (f == null) {
            return;
        }
        this.k7.j(a.c, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    }
    get_az() {
        return 3;
    }
    get az() {
        return this.get_az();
    }
}
NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
Type.dep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'gt', ['InnerRadiusExtentScale:lk:ls', [1, 0], 'RadiusExtentScale:ll:lt', [1, 0.75]]);
export class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.ax = null;
        this.ax = a;
    }
    am() {
        super.am();
        this.ax.ct = true;
    }
    ay(a, b) {
        this.ax.cx = -1.7976931348623157E+308;
        this.ax.cu = -1.7976931348623157E+308;
        this.ax.cw = -1.7976931348623157E+308;
        this.ax.cv = -1.7976931348623157E+308;
        for (let c = 0; c < this.a.a3.count; c++) {
            let d = this.a.a3._inner[c];
            let e = this.a.a2._inner[c];
            let f = e.a;
            let g = this.ax.cz(e.d);
            let h = this.m(d);
            let i = this.l(d);
            let j = h + this.p() + this.q();
            let k = i + this.r() + this.o();
            let l = g.x - j / 2;
            let m = g.y - k / 2;
            this.ax.cw = Math.max(h, this.ax.cw);
            this.ax.cv = Math.max(i, this.ax.cv);
            this.ax.cx = Math.max(j, this.ax.cx);
            this.ax.cu = Math.max(k, this.ax.cu);
            let n = new Rect(0, l, m, j, k);
            a.add(n);
            b.add(f);
        }
    }
    o() {
        return 0;
    }
    p() {
        return 0;
    }
    q() {
        return 0;
    }
    r() {
        return 0;
    }
}
AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
export class CategoryAngleAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bf = null;
        this.bf = a;
    }
}
CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
export class NumericAngleAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bf = null;
        this.bf = a;
    }
}
NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
export class NumericRadiusAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bf = null;
        this.bf = a;
    }
}
NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
